Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | List of all members
Botan::Certificate_Store_In_Memory Class Referencefinal

`#include <certstor.h>`

Inheritance diagram for Botan::Certificate_Store_In_Memory:

## Public Member Functions
void | add_certificate (const X509_Certificate &cert)
void | add_certificate (std::shared_ptr< const X509_Certificate > cert)
void | add_crl (const X509_CRL &crl)
void | add_crl (std::shared_ptr< const X509_CRL > crl)
std::vector< X509_DN > | all_subjects () const override
bool | certificate_known (const X509_Certificate &cert) const
| Certificate_Store_In_Memory ()=default
| Certificate_Store_In_Memory (const std::string &dir)
| Certificate_Store_In_Memory (const X509_Certificate &cert)
| Certificate_Store_In_Memory (std::vector< std::shared_ptr< const X509_Certificate > > certs)
std::vector< std::shared_ptr< const X509_Certificate > > | find_all_certs (const X509_DN &subject_dn, const std::vector< uint8_t > &key_id) const override
std::shared_ptr< const X509_Certificate > | find_cert (const X509_DN &subject_dn, const std::vector< uint8_t > &key_id) const override
std::shared_ptr< const X509_Certificate > | find_cert_by_pubkey_sha1 (const std::vector< uint8_t > &key_hash) const override
std::shared_ptr< const X509_Certificate > | find_cert_by_raw_subject_dn_sha256 (const std::vector< uint8_t > &subject_hash) const override
std::shared_ptr< const X509_CRL > | find_crl_for (const X509_Certificate &subject) const override

## Detailed Description

In Memory Certificate Store

Definition at line 84 of file certstor.h.

## Constructor & Destructor Documentation

## ◆ Certificate_Store_In_Memory() [1/4]

Botan::Certificate_Store_In_Memory::Certificate_Store_In_Memory | ( | const std::string & | dir | ) |
| explicit

Attempt to parse all files in dir (including subdirectories) as certificates. Ignores errors.

## ◆ Certificate_Store_In_Memory() [2/4]

Botan::Certificate_Store_In_Memory::Certificate_Store_In_Memory | ( | const X509_Certificate & | cert | ) |
| explicit

Adds given certificate to the store.

Definition at line 190 of file certstor.cpp.

191 {
192 add_certificate(cert);
193 }
Botan::Certificate_Store_In_Memory::add_certificate
void add_certificate(const X509_Certificate &cert)
Definition: certstor.cpp:38

References add_certificate().

## ◆ Certificate_Store_In_Memory() [3/4]

Botan::Certificate_Store_In_Memory::Certificate_Store_In_Memory | ( | std::vector< std::shared_ptr< const X509_Certificate > > | certs | ) |
| inline explicit

Adds given certificate list to the store.

Definition at line 101 of file certstor.h.

102 : m_certs(std::move(certs)) {}

## ◆ Certificate_Store_In_Memory() [4/4]

Botan::Certificate_Store_In_Memory::Certificate_Store_In_Memory | ( |  | ) |
| default

Create an empty store.

## Member Function Documentation

## ◆ add_certificate() [1/2]

void Botan::Certificate_Store_In_Memory::add_certificate | ( | const X509_Certificate & | cert | ) |

Add a certificate to the store.

Parameters

  cert | certificate to be added

Definition at line 38 of file certstor.cpp.

39 {
40 for(const auto& c : m_certs)
41 if(*c == cert)
42 return;
43
44 m_certs.push_back(std::make_shared<const X509_Certificate>(cert));
45 }

Referenced by Botan::PKIX::build_all_certificate_paths(), Botan::PKIX::build_certificate_path(), and Certificate_Store_In_Memory().

## ◆ add_certificate() [2/2]

void Botan::Certificate_Store_In_Memory::add_certificate | ( | std::shared_ptr< const X509_Certificate > | cert | ) |

Add a certificate already in a shared_ptr to the store.

Parameters

  cert | certificate to be added

Definition at line 47 of file certstor.cpp.

48 {
49 for(const auto& c : m_certs)
50 if(*c == *cert)
51 return;
52
53 m_certs.push_back(cert);
54 }

## ◆ add_crl() [1/2]

void Botan::Certificate_Store_In_Memory::add_crl | ( | const X509_CRL & | crl | ) |

Add a certificate revocation list (CRL) to the store.

Parameters

  crl | CRL to be added

Definition at line 143 of file certstor.cpp.

144 {
145 std::shared_ptr<const X509_CRL> crl_s = std::make_shared<const X509_CRL>(crl);
146 return add_crl(crl_s);
147 }
Botan::Certificate_Store_In_Memory::add_crl
void add_crl(const X509_CRL &crl)
Definition: certstor.cpp:143

References add_crl().

Referenced by add_crl().

## ◆ add_crl() [2/2]

void Botan::Certificate_Store_In_Memory::add_crl | ( | std::shared_ptr< const X509_CRL > | crl | ) |

Add a certificate revocation list (CRL) to the store as a shared_ptr

Parameters

  crl | CRL to be added

Definition at line 149 of file certstor.cpp.

150 {
151 X509_DN crl_issuer = crl->issuer_dn();
152
153 for(auto& c : m_crls)
154 {
155 // Found an update of a previously existing one; replace it
156 if(c->issuer_dn() == crl_issuer)
157 {
158 if(c->this_update() <= crl->this_update())
159 c = crl;
160 return;
161 }
162 }
163
164 // Totally new CRL, add to the list
165 m_crls.push_back(crl);
166 }

## ◆ all_subjects()

std::vector< X509_DN > Botan::Certificate_Store_In_Memory::all_subjects | ( |  | ) | const
| override virtual

Returns
  DNs for all certificates managed by the store

Implements Botan::Certificate_Store.

Definition at line 56 of file certstor.cpp.

57 {
58 std::vector<X509_DN> subjects;
59 for(const auto& cert : m_certs)
60 subjects.push_back(cert->subject_dn());
61 return subjects;
62 }

## ◆ certificate_known()

bool Botan::Certificate_Store::certificate_known | ( | const X509_Certificate & | cert | ) | const
| inline inherited

Returns
  whether the certificate is known

Parameters

  cert | certififcate to be searched

Definition at line 72 of file certstor.h.

73 {
74 return find_cert(cert.subject_dn(), cert.subject_key_id()) != nullptr;
75 }
Botan::Certificate_Store::find_cert
virtual std::shared_ptr< const X509_Certificate > find_cert(const X509_DN &subject_dn, const std::vector< uint8_t > &key_id) const
Definition: certstor.cpp:20

References Botan::X509_Certificate::subject_dn(), and Botan::X509_Certificate::subject_key_id().

## ◆ find_all_certs()

std::vector< std::shared_ptr< const X509_Certificate > > Botan::Certificate_Store_In_Memory::find_all_certs | ( | const X509_DN & | subject_dn,
|  | const std::vector< uint8_t > & | key_id
| ) |  | const
| override virtual

Find all certificates with a given Subject DN. Subject DN and even the key identifier might not be unique.

Implements Botan::Certificate_Store.

Definition at line 86 of file certstor.cpp.

89 {
90 std::vector<std::shared_ptr<const X509_Certificate>> matches;
91
92 for(const auto& cert : m_certs)
93 {
94 if(key_id.size())
95 {
96 std::vector<uint8_t> skid = cert->subject_key_id();
97
98 if(skid.size() && skid != key_id) // no match
99 continue;
100 }
101
102 if(cert->subject_dn() == subject_dn)
103 matches.push_back(cert);
104 }
105
106 return matches;
107 }
Botan::PEM_Code::matches
bool matches(DataSource &source, const std::string &extra, size_t search_range)
Definition: pem.cpp:142

References Botan::PEM_Code::matches().

Referenced by Botan::PKIX::build_all_certificate_paths().

## ◆ find_cert()

std::shared_ptr< const X509_Certificate > Botan::Certificate_Store_In_Memory::find_cert | ( | const X509_DN & | subject_dn,
|  | const std::vector< uint8_t > & | key_id
| ) |  | const
| override virtual

Find a certificate by Subject DN and (optionally) key identifier

Parameters

  subject_dn | the subject's distinguished name
  key_id | an optional key id

Returns
  a matching certificate or nullptr otherwise If more than one certificate in the certificate store matches, then a single value is selected arbitrarily.

Reimplemented from Botan::Certificate_Store.

Definition at line 65 of file certstor.cpp.

67 {
68 for(const auto& cert : m_certs)
69 {
70 // Only compare key ids if set in both call and in the cert
71 if(key_id.size())
72 {
73 std::vector<uint8_t> skid = cert->subject_key_id();
74
75 if(skid.size() && skid != key_id) // no match
76 continue;
77 }
78
79 if(cert->subject_dn() == subject_dn)
80 return cert;
81 }
82
83 return nullptr;
84 }

Referenced by Botan::PKIX::build_certificate_path(), and Botan::OCSP::Response::check_signature().

## ◆ find_cert_by_pubkey_sha1()

std::shared_ptr< const X509_Certificate > Botan::Certificate_Store_In_Memory::find_cert_by_pubkey_sha1 | ( | const std::vector< uint8_t > & | key_hash | ) | const
| override virtual

Find a certificate by searching for one with a matching SHA-1 hash of public key. Used for OCSP.

Parameters

  key_hash | SHA-1 hash of the subject's public key

Returns
  a matching certificate or nullptr otherwise

Implements Botan::Certificate_Store.

Definition at line 110 of file certstor.cpp.

111 {
112 if(key_hash.size() != 20)
113 throw Invalid_Argument("Certificate_Store_In_Memory::find_cert_by_pubkey_sha1 invalid hash");
114
115 std::unique_ptr<HashFunction> hash(HashFunction::create("SHA-1"));
116
117 for(const auto& cert : m_certs){
118 hash->update(cert->subject_public_key_bitstring());
119 if(key_hash == hash->final_stdvec()) //final_stdvec also clears the hash to initial state
120 return cert;
121 }
122
123 return nullptr;
124 }
Botan::HashFunction::create
static std::unique_ptr< HashFunction > create(const std::string &algo_spec, const std::string &provider="")
Definition: hash.cpp:102
hash
MechanismType hash
Definition: p11_mechanism.cpp:64

References Botan::HashFunction::create(), and hash.

## ◆ find_cert_by_raw_subject_dn_sha256()

std::shared_ptr< const X509_Certificate > Botan::Certificate_Store_In_Memory::find_cert_by_raw_subject_dn_sha256 | ( | const std::vector< uint8_t > & | subject_hash | ) | const
| override virtual

Find a certificate by searching for one with a matching SHA-256 hash of raw subject name. Used for OCSP.

Parameters

  subject_hash | SHA-256 hash of the subject's raw name

Returns
  a matching certificate or nullptr otherwise

Implements Botan::Certificate_Store.

Definition at line 127 of file certstor.cpp.

128 {
129 if(subject_hash.size() != 32)
130 throw Invalid_Argument("Certificate_Store_In_Memory::find_cert_by_raw_subject_dn_sha256 invalid hash");
131
132 std::unique_ptr<HashFunction> hash(HashFunction::create("SHA-256"));
133
134 for(const auto& cert : m_certs){
135 hash->update(cert->raw_subject_dn());
136 if(subject_hash == hash->final_stdvec()) //final_stdvec also clears the hash to initial state
137 return cert;
138 }
139
140 return nullptr;
141 }

References Botan::HashFunction::create(), and hash.

## ◆ find_crl_for()

std::shared_ptr< const X509_CRL > Botan::Certificate_Store_In_Memory::find_crl_for | ( | const X509_Certificate & | subject | ) | const
| override virtual

Finds a CRL for the given certificate

Reimplemented from Botan::Certificate_Store.

Definition at line 168 of file certstor.cpp.

169 {
170 const std::vector<uint8_t>& key_id = subject.authority_key_id();
171
172 for(const auto& c : m_crls)
173 {
174 // Only compare key ids if set in both call and in the CRL
175 if(key_id.size())
176 {
177 std::vector<uint8_t> akid = c->authority_key_id();
178
179 if(akid.size() && akid != key_id) // no match
180 continue;
181 }
182
183 if(c->issuer_dn() == subject.issuer_dn())
184 return c;
185 }
186
187 return {};
188 }

References Botan::X509_Certificate::authority_key_id(), and Botan::X509_Certificate::issuer_dn().

The documentation for this class was generated from the following files:

- src/lib/x509/certstor.h
- src/lib/x509/certstor.cpp